%
% This file is part of AtomVM.
%
% Copyright 2023 Paul Guyot <pguyot@kallisys.net>
%
% Licensed under the Apache License, Version 2.0 (the "License");
% you may not use this file except in compliance with the License.
% You may obtain a copy of the License at
%
%    http://www.apache.org/licenses/LICENSE-2.0
%
% Unless required by applicable law or agreed to in writing, software
% distributed under the License is distributed on an "AS IS" BASIS,
% WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
% See the License for the specific language governing permissions and
% limitations under the License.
%
% SPDX-License-Identifier: Apache-2.0 OR LGPL-2.1-or-later
%

-module(test_tz).
-export([start/0]).

start() ->
    UTCTime1 = erlang:universaltime(),
    LocalTimeUTC = erlang:localtime("UTC"),
    UTCTime2 = erlang:universaltime(),
    true = UTCTime1 =< LocalTimeUTC andalso LocalTimeUTC =< UTCTime2,
    ParisTime = erlang:localtime("CET-1CEST,M3.5.0,M10.5.0/3"),
    UTCTime3 = erlang:universaltime(),
    true = UTCTime2 =/= ParisTime andalso UTCTime3 =/= ParisTime,
    ok.
