%
% This file is part of AtomVM.
%
% Copyright 2018 Davide Bettio <davide@uninstall.it>
%
% Licensed under the Apache License, Version 2.0 (the "License");
% you may not use this file except in compliance with the License.
% You may obtain a copy of the License at
%
%    http://www.apache.org/licenses/LICENSE-2.0
%
% Unless required by applicable law or agreed to in writing, software
% distributed under the License is distributed on an "AS IS" BASIS,
% WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
% See the License for the specific language governing permissions and
% limitations under the License.
%
% SPDX-License-Identifier: Apache-2.0 OR LGPL-2.1-or-later
%

-module(test_gt_and_le).

-export([start/0, f/4, h/4, i/4, j/4]).

start() ->
    g(f(5, 5, -1, 1), 1) +
        g(h(0, -1, -2, -3), 2) +
        g(i(-2, -2, 10, 0), 4) +
        g(j(-2, -2, -10, 5), 8) +
        g(not f(5, 3, -1, -10), 16) +
        g(not h(1, 2, -1, 5), 32) +
        g(not i(1, 2, -1, 5), 64) +
        g(not j(5, 3, -1, -10), 128).

f(A, B, C, D) ->
    (A < B) xor (C < D).

h(A, B, C, D) ->
    (A > B) and (B > C) and (C > D).

i(A, B, C, D) ->
    (A >= B) and (C >= D).

j(A, B, C, D) ->
    (A =< B) and (C =< D).

g(true, N) ->
    N;
g(false, _N) ->
    0.
